//! # This is the image processing library for iOwO
//!
//! One of the design goals for this library is, however, to be a simple, generic image processing library.
//! For now, it's just indev... lets see what comes of it!
#![feature(lint_reasons)]

/// just some experiments, to test whether the architecture i want is even possible (or how to do it). probably temporary.
/// Gonna first try string processing...
pub mod experimental;

#[test]
fn test_enums() {
    use crate::experimental::enum_based::{Instruction, PipelineBuilder};
    let builder = PipelineBuilder::new().insert(Instruction::Uppercase);
    let upr = builder.build();
    let upr_lowr = builder.insert(Instruction::Lowercase).build();

    assert_eq!(upr.run(String::from("Test")), String::from("TEST"));
    assert_eq!(upr_lowr.run(String::from("Test")), String::from("test"));
}
